(function( $ ){

  var methods ={};

  $.fn.booleanImage = function( method ) {

    // Method calling logic
    if ( methods[method] ) {
      return methods[ method ].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.booleanImage' );
    }    

  };

  methods.init = function(options)
    {
    var settings = $.extend({
        data:[],
        onSelected:function(){},
        indicator:false
        },options);

    return $(this).each(function(){
      $(this).data('booleanImage',settings);
     if (!settings.indicator)
        {
        $(this).mouseup(function(){
           settings.onSelected.call();
          });  
        }
      });
    }

  methods.select = function(selected_value)
    {
    selectIndex($(this),selected_value);
    }

  function selectIndex(obj,selected_value)
    {
    image_data_array = obj.data('booleanImage');
    if (selected_value=="FALSE")
      {
      obj.data("value",0);
      obj.attr("src",image_data_array.data[0].imageSrc);
      }
    else
      {
      obj.data("value",1);
      obj.attr("src",image_data_array.data[1].imageSrc);
      }
    }
})( jQuery );
