(function( $ ){

  var methods ={};

  $.fn.enum = function( method ) {

    // Method calling logic
    if ( methods[method] ) {
      return methods[ method ].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.booleanImage' );
    }    

  };

  methods.init = function(options)
    {
    var settings = $.extend({
        data:[],
        onSelected:function(){},
        indicator:false
        },options);

    return $(this).each(function(){
      $(this).data('enum',settings);
      if (!settings.indicator)
        {
        html_str = "";
        for (i=0;i<=(settings.data.length-1);i++)
          {
          html_str = html_str + "<option value="+i+">"+settings.data[i]+"</option>"; 
          } 
        $(this).html(html_str);
        $(this).on("change",function(){
          settings.onSelected.call();
          });  
        }
      });
    }

  methods.select = function(selected_value)
    {
    selectIndex($(this),selected_value);
    }

  function selectIndex(obj,selected_value)
    {
    enum_data = obj.data('enum');
    if (!enum_data.indicator)
      {
      // Enum Control
      obj.val(selected_value);
      }
    else
      {
      // Enum Indicator
      obj.val(enum_data.data[selected_value]);
      }
    }
})( jQuery );
